## 2e2338e57f9a99fd4789572be2b0230c7512a67d.tar.gz

=== allwpilib/CMakeLists.txt ===
# Disable in-source builds to prevent source tree corruption.
if(" ${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL " ${CMAKE_CURRENT_BINARY_DIR}")
    message(
        FATAL_ERROR
        "
FATAL: In-source builds are not allowed.
       You should create a separate directory for build files.
"
    )
endif()

if("${CMAKE_HOST_SYSTEM_NAME}" STREQUAL "Windows")
    set(CMAKE_SYSTEM_VERSION 10.0.18362.0 CACHE STRING INTERNAL FORCE)
    set(CMAKE_VS_WINDOWS_TARGET_PLATFORM_VERSION 10.0.18362.0 CACHE STRING INTERNAL FORCE)
endif()

cmake_minimum_required(VERSION 3.11)
project(allwpilib)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")

# Make timestamps of extracted files from FetchContent the time of extraction
if(POLICY CMP0135)
    cmake_policy(SET CMP0135 NEW)
endif()

message(STATUS "Platform version: ${CMAKE_VS_WINDOWS_TARGET_PLATFORM_VERSION}")

set(WPILIB_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})

include(CPack)

set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${WPILIB_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${WPILIB_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${WPILIB_BINARY_DIR}/bin)
set(CMAKE_JAVA_TARGET_OUTPUT_DIR ${WPILIB_BINARY_DIR}/jar)

# use, i.e. don't skip the full RPATH for the build tree
set(CMAKE_SKIP_BUILD_RPATH FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# the RPATH to be used when installing, but only if it's not a system directory
list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
if("${isSystemDir}" STREQUAL "-1")
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
endif()

# Options for building certain parts of the repo. Everything is built by default.
option(BUILD_SHARED_LIBS "Build with shared libs (needed for JNI)" ON)
option(WITH_JAVA "Include Java and JNI in the build" ON)
option(WITH_JAVA_SOURCE "Build Java source jars" ${WITH_JAVA})
option(WITH_CSCORE "Build cscore (needs OpenCV)" ON)
option(WITH_NTCORE "Build ntcore" ON)
option(WITH_WPIMATH "Build wpimath" ON)
option(WITH_WPIUNITS "Build wpiunits" ON)
option(WITH_WPILIB "Build hal, wpilibc/j, and myRobot (needs OpenCV)" ON)
option(WITH_EXAMPLES "Build examples" OFF)
option(WITH_TESTS "Build unit tests (requires internet connection)" ON)
option(WITH_GUI "Build GUI items" ON)
option(WITH_SIMULATION_MODULES "Build simulation modules" ON)

# Options for external HAL.
option(WITH_EXTERNAL_HAL "Use a separately built HAL" OFF)
set(EXTERNAL_HAL_FILE "" CACHE FILEPATH "Location to look for an external HAL CMake File")

# Options for using a package manager (e.g., vcpkg) for certain dependencies.
option(USE_SYSTEM_FMTLIB "Use system fmtlib" OFF)
option(USE_SYSTEM_LIBUV "Use system libuv" OFF)
option(USE_SYSTEM_EIGEN "Use system eigen" OFF)

# Options for location of OpenCV Java.
set(OPENCV_JAVA_INSTALL_DIR "" CACHE PATH "Location to search for the OpenCV jar file")

# Options for compilation flags.
option(NO_WERROR "Disable -Werror flag during compilation" OFF)

# Set default build type to release with debug info (i.e. release mode optimizations
# are performed, but debug info still exists).
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "" FORCE)
endif()

if(WITH_JAVA AND NOT BUILD_SHARED_LIBS)
    message(
        FATAL_ERROR
        "
FATAL: Cannot build static libs with Java enabled.
       Static libs requires both BUILD_SHARED_LIBS=OFF and
       WITH_JAVA=OFF
"
    )
endif()

if(WITH_SIMULATION_MODULES AND NOT BUILD_SHARED_LIBS)
    message(
        FATAL_ERROR
        "
FATAL: Cannot build static libs with simulation modules enabled.
       Static libs requires both BUILD_SHARED_LIBS=OFF and
       WITH_SIMULATION_MODULES=OFF
"
    )
endif()

if(NOT WITH_JAVA OR NOT WITH_CSCORE)
    if(NOT "${OPENCV_JAVA_INSTALL_DIR}" STREQUAL "")
        message(
            WARNING
            "
WARNING: OpenCV Java dir set but java is not enabled!
It will be ignored.
"
        )
    endif()
endif()

if(NOT WITH_WPILIB AND WITH_SIMULATION_MODULES)
    message(
        FATAL_ERROR
        "
FATAL: Cannot build simulation modules with wpilib disabled.
       Enable wpilib by setting WITH_WPILIB=ON
"
    )
endif()

if(NOT WITH_NTCORE AND WITH_CSCORE)
    message(
        FATAL_ERROR
        "
FATAL: Cannot build cameraserver without ntcore.
       Enable ntcore by setting WITH_NTCORE=ON
"
    )
endif()

if(NOT WITH_NTCORE AND WITH_GUI)
    message(
        FATAL_ERROR
        "
FATAL: Cannot build GUI modules without ntcore.
       Enable ntcore by setting WITH_NTCORE=ON
"
    )
endif()

if(NOT WITH_NTCORE AND WITH_SIMULATION_MODULES)
    message(
        FATAL_ERROR
        "
FATAL: Cannot build simulation modules without ntcore.
       Enable ntcore by setting WITH_NTCORE=ON
"
    )
endif()

if(NOT WITH_NTCORE AND WITH_WPILIB)
    message(
        FATAL_ERROR
        "
FATAL: Cannot build wpilib without ntcore.
       Enable ntcore by setting WITH_NTCORE=ON
"
    )
endif()

if(NOT WITH_WPIMATH AND WITH_WPILIB)
    message(
        FATAL_ERROR
        "
FATAL: Cannot build wpilib without wpimath.
       Enable wpimath by setting WITH_WPIMATH=ON
"
    )
endif()

if(NOT WITH_WPIUNITS AND WITH_WPIMATH AND WITH_JAVA)
    message(
        FATAL_ERROR
        "
FATAL: Cannot build Java wpimath without wpiunits.
       Enable wpiunits by setting WITH_WPIUNITS=ON or disable the Java build by setting WITH_JAVA=OFF
"
    )
endif()

set(include_dest include)
set(java_lib_dest java)
set(jni_lib_dest jni)

if(USE_SYSTEM_LIBUV)
    set(LIBUV_SYSTEM_REPLACE
        "
find_dependency(libuv CONFIG)
"
    )
endif()

if(USE_SYSTEM_EIGEN)
    set(EIGEN_SYSTEM_REPLACE "find_package(Eigen3 CONFIG)")
endif()

find_package(LIBSSH 0.7.1)

find_package(Protobuf REQUIRED)

set(APRILTAG_DEP_REPLACE "find_dependency(apriltag)")
set(CAMERASERVER_DEP_REPLACE_IMPL "find_dependency(cameraserver)")
set(CSCORE_DEP_REPLACE_IMPL "find_dependency(cscore)")
set(HAL_DEP_REPLACE_IMPL "find_dependency(hal)")
set(NTCORE_DEP_REPLACE "find_dependency(ntcore)")
set(WPILIBC_DEP_REPLACE_IMPL "find_dependency(wpilibc)")
set(WPILIBJ_DEP_REPLACE "find_dependency(wpilibj)")
set(WPILIBNEWCOMMANDS_DEP_REPLACE "find_dependency(wpilibNewCommands)")
set(WPIMATH_DEP_REPLACE "find_dependency(wpimath)")
set(WPINET_DEP_REPLACE "find_dependency(wpinet)")
set(WPIUNITS_DEP_REPLACE "find_dependency(wpiunits)")
set(WPIUTIL_DEP_REPLACE "find_dependency(wpiutil)")

set(FILENAME_DEP_REPLACE "get_filename_component(SELF_DIR \"$\{CMAKE_CURRENT_LIST_FILE\}\" PATH)")
set(SELF_DIR "$\{SELF_DIR\}")

get_property(isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)

if(isMultiConfig)
    if(NOT "Asan" IN_LIST CMAKE_CONFIGURATION_TYPES)
        list(APPEND CMAKE_CONFIGURATION_TYPES Asan)
    endif()
    if(NOT "Tsan" IN_LIST CMAKE_CONFIGURATION_TYPES)
        list(APPEND CMAKE_CONFIGURATION_TYPES Tsan)
    endif()
    if(NOT "Ubsan" IN_LIST CMAKE_CONFIGURATION_TYPES)
        list(APPEND CMAKE_CONFIGURATION_TYPES Ubsan)
    endif()
else()
    set(allowedBuildTypes
        Asan
        Tsan
        Ubsan
        Debug
        Release
        RelWithDebInfo
        MinSizeRel
    )
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "${allowedBuildTypes}")

    if(CMAKE_BUILD_TYPE AND NOT CMAKE_BUILD_TYPE IN_LIST allowedBuildTypes)
        message(FATAL_ERROR "Invalid build type: ${CMAKE_BUILD_TYPE}")
    endif()
endif()

set(CMAKE_C_FLAGS_ASAN
    "${CMAKE_C_FLAGS_DEBUG} -fsanitize=address -fno-omit-frame-pointer"
    CACHE STRING
    "Flags used by the C compiler for Asan build type or configuration."
    FORCE
)

set(CMAKE_CXX_FLAGS_ASAN
    "${CMAKE_CXX_FLAGS_DEBUG} -fsanitize=address -fno-omit-frame-pointer"
    CACHE STRING
    "Flags used by the C++ compiler for Asan build type or configuration."
    FORCE
)

set(CMAKE_EXE_LINKER_FLAGS_ASAN
    "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} -fsanitize=address"
    CACHE STRING
    "Linker flags to be used to create executables for Asan build type."
    FORCE
)

set(CMAKE_SHARED_LINKER_FLAGS_ASAN
    "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} -fsanitize=address"
    CACHE STRING
    "Linker lags to be used to create shared libraries for Asan build type."
    FORCE
)

set(CMAKE_C_FLAGS_TSAN
    "${CMAKE_C_FLAGS_DEBUG} -fsanitize=thread -fno-omit-frame-pointer"
    CACHE STRING
    "Flags used by the C compiler for Tsan build type or configuration."
    FORCE
)

set(CMAKE_CXX_FLAGS_TSAN
    "${CMAKE_CXX_FLAGS_DEBUG} -fsanitize=thread -fno-omit-frame-pointer"
    CACHE STRING
    "Flags used by the C++ compiler for Tsan build type or configuration."
    FORCE
)

set(CMAKE_EXE_LINKER_FLAGS_TSAN
    "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} -fsanitize=thread"
    CACHE STRING
    "Linker flags to be used to create executables for Tsan build type."
    FORCE
)

set(CMAKE_SHARED_LINKER_FLAGS_TSAN
    "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} -fsanitize=thread"
    CACHE STRING
    "Linker lags to be used to create shared libraries for Tsan build type."
    FORCE
)

set(CMAKE_C_FLAGS_UBSAN
    "${CMAKE_C_FLAGS_DEBUG} -fsanitize=undefined -fno-sanitize-recover=all -fno-omit-frame-pointer"
    CACHE STRING
    "Flags used by the C compiler for Ubsan build type or configuration."
    FORCE
)

set(CMAKE_CXX_FLAGS_UBSAN
    "${CMAKE_CXX_FLAGS_DEBUG} -fsanitize=undefined -fno-sanitize-recover=all -fno-omit-frame-pointer"
    CACHE STRING
    "Flags used by the C++ compiler for Ubsan build type or configuration."
    FORCE
)

set(CMAKE_EXE_LINKER_FLAGS_UBSAN
    "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} -fsanitize=undefined -fno-sanitize-recover=all"
    CACHE STRING
    "Linker flags to be used to create executables for Ubsan build type."
    FORCE
)

set(CMAKE_SHARED_LINKER_FLAGS_UBSAN
    "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} -fsanitize=undefined"
    CACHE STRING
    "Linker lags to be used to create shared libraries for Ubsan build type."
    FORCE
)

if(WITH_TESTS)
    enable_testing()
    add_subdirectory(googletest)
    include(GoogleTest)
endif()

add_subdirectory(wpiutil)

if(WITH_NTCORE)
    add_subdirectory(wpinet)
    add_subdirectory(ntcore)
endif()

if(WITH_WPIMATH)
    if(WITH_JAVA)
        add_subdirectory(wpiunits)
    endif()
    add_subdirectory(wpimath)
endif()

if(WITH_WPIUNITS AND NOT WITH_WPIMATH)
    # In case of building wpiunits standalone
    add_subdirectory(wpiunits)
endif()

if(WITH_GUI)
    add_subdirectory(fieldImages)
    add_subdirectory(imgui)
    add_subdirectory(wpigui)
    add_subdirectory(glass)
    add_subdirectory(outlineviewer)
    add_subdirectory(sysid)
    if(LIBSSH_FOUND)
        add_subdirectory(roborioteamnumbersetter)
        add_subdirectory(datalogtool)
    endif()
endif()

if(WITH_WPILIB OR WITH_SIMULATION_MODULES)
    set(HAL_DEP_REPLACE ${HAL_DEP_REPLACE_IMPL})
    add_subdirectory(hal)
endif()

if(WITH_CSCORE)
    set(CSCORE_DEP_REPLACE ${CSCORE_DEP_REPLACE_IMPL})
    set(CAMERASERVER_DEP_REPLACE ${CAMERASERVER_DEP_REPLACE_IMPL})
    add_subdirectory(cscore)
    add_subdirectory(cameraserver)
endif()

if(WITH_WPILIB)
    set(WPILIBC_DEP_REPLACE ${WPILIBC_DEP_REPLACE_IMPL})
    add_subdirectory(apriltag)
    add_subdirectory(wpilibj)
    add_subdirectory(wpilibc)
    add_subdirectory(wpilibNewCommands)
    add_subdirectory(romiVendordep)
    add_subdirectory(xrpVendordep)
    if(WITH_EXAMPLES)
        add_subdirectory(wpilibcExamples)
    endif()
    add_subdirectory(myRobot)
endif()

if(WITH_SIMULATION_MODULES AND NOT WITH_EXTERNAL_HAL)
    add_subdirectory(simulation)
endif()

configure_file(wpilib-config.cmake.in ${WPILIB_BINARY_DIR}/wpilib-config.cmake)

=== imu/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

# Pull in SDK (must be before project)
include(pico_sdk_import.cmake)

project(ADIS16505_communication C CXX ASM)
set(CMAKE_C_STANDARD 11)
set(CMAKE_CXX_STANDARD 17)

if (PICO_SDK_VERSION_STRING VERSION_LESS "1.3.0")
    message(FATAL_ERROR "Raspberry Pi Pico SDK version 1.3.0 (or later) required. Your version is ${PICO_SDK_VERSION_STRING}")
endif()

# Initialize the SDK
pico_sdk_init()

add_compile_options(-Wall
        -Wno-format          # int != int32_t as far as the compiler is concerned because gcc has int32_t as long int
        -Wno-unused-function # we have some for the docs that aren't called
        -Wno-maybe-uninitialized
        )

add_executable(pico_imu_board)

pico_generate_pio_header(pico_imu_board ${CMAKE_CURRENT_LIST_DIR}/quadrature_encoder.pio)

target_sources(pico_imu_board PRIVATE ADIS16505.cc)

# pull in common dependencies
target_link_libraries(pico_imu_board
  pico_stdlib
  hardware_spi
  hardware_dma
  hardware_irq
  hardware_pwm
  hardware_pio
  hardware_timer
  pico_bootrom
  pico_double
  )

# enable usb output, disable uart output
pico_enable_stdio_usb(pico_imu_board 1)
pico_enable_stdio_uart(pico_imu_board 1)

# create map/bin/hex file etc.
pico_add_extra_outputs(pico_imu_board)

=== libjpeg/CMakeLists.txt ===
# Copyright (C) 2007-2012 LuaDist.
# Created by Peter Kapec, David Manura
# Redistribution and use of this file is allowed according to the terms of the MIT license.
# For details see the COPYRIGHT file distributed with LuaDist.
# Please note that the package source code is licensed under its own license.

project ( libjpeg C )
cmake_minimum_required ( VERSION 2.8 )
include ( cmake/dist.cmake )

include ( CheckIncludeFile )
check_include_file ( stddef.h HAVE_STDDEF_H )
check_include_file ( stdlib.h HAVE_STDLIB_H )
if ( WIN32 AND NOT CYGWIN )
  #improve? see jconfig.*
  set ( TWO_FILE_COMMANDLINE true )
  # jconfig.h
endif ( )
configure_file ( jconfig.h.cmake jconfig.h )

include_directories ( ${CMAKE_CURRENT_BINARY_DIR} )
# jconfig.h

set ( HEADERS jerror.h jmorecfg.h jpeglib.h ${CMAKE_CURRENT_BINARY_DIR}/jconfig.h )

set ( SRC jmemnobs.c jaricom.c jcapimin.c jcapistd.c jcarith.c jccoefct.c jccolor.c 
  jcdctmgr.c jchuff.c jcinit.c jcmainct.c jcmarker.c jcmaster.c jcomapi.c jcparam.c 
  jcprepct.c jcsample.c jctrans.c jdapimin.c jdapistd.c jdarith.c jdatadst.c jdatasrc.c 
  jdcoefct.c jdcolor.c jddctmgr.c jdhuff.c jdinput.c jdmainct.c jdmarker.c jdmaster.c 
  jdmerge.c jdpostct.c jdsample.c jdtrans.c jerror.c jfdctflt.c jfdctfst.c jfdctint.c 
  jidctflt.c jidctfst.c jidctint.c jquant1.c jquant2.c jutils.c jmemmgr.c cderror.h 
  cdjpeg.h jdct.h jinclude.h jmemsys.h jpegint.h jversion.h transupp.h )

add_library ( jpeg ${SRC} ${HEADERS} )

add_executable ( cjpeg cdjpeg.c cjpeg.c rdbmp.c rdgif.c rdppm.c rdrle.c rdtarga.c 
  rdswitch.c )
add_executable ( djpeg cdjpeg.c djpeg.c wrbmp.c wrgif.c wrppm.c wrrle.c wrtarga.c 
  rdcolmap.c )
add_executable ( jpegtran jpegtran.c cdjpeg.c rdswitch.c transupp.c )
add_executable ( rdjpgcom rdjpgcom.c )
add_executable ( wrjpgcom wrjpgcom.c )
target_link_libraries ( cjpeg jpeg )
target_link_libraries ( djpeg jpeg )
target_link_libraries ( jpegtran jpeg )

install_executable ( cjpeg djpeg jpegtran rdjpgcom wrjpgcom )
install_library ( jpeg )
install_header ( ${HEADERS} )
install_doc ( README install.txt usage.txt wizard.txt example.c libjpeg.txt structure.txt 
  coderules.txt filelist.txt change.log )

# tests
enable_testing ( )
macro ( mytest name target args input output )
get_target_property ( _cmdpath ${target} LOCATION )
add_test ( ${name} ${CMAKE_COMMAND} "-DCOMMAND=${_cmdpath} ${args}" "-DINPUT=${input}" 
  "-DOUTPUT=${output}" -P ${CMAKE_CURRENT_SOURCE_DIR}/jpeg_test.cmake )
endmacro ( )
set ( _src "${CMAKE_CURRENT_SOURCE_DIR}" )
mytest ( t1 djpeg "-dct int -ppm -outfile testout.ppm ${_src}/testorig.jpg" "${_src}/testimg.ppm" 
  testout.ppm )
mytest ( t2 djpeg "-dct int -bmp -colors 256 -outfile testout.bmp ${_src}/testorig.jpg" 
  ${_src}/testimg.bmp testout.bmp )
mytest ( t3 cjpeg "-dct int -outfile testout.jpg ${_src}/testimg.ppm" ${_src}/testimg.jpg 
  testout.jpg )
mytest ( t4 djpeg "-dct int -ppm -outfile testoutp.ppm ${_src}/testprog.jpg" ${_src}/testimg.ppm 
  testoutp.ppm )
mytest ( t5 cjpeg "-dct int -progressive -opt -outfile testoutp.jpg ${_src}/testimg.ppm" 
  ${_src}/testimgp.jpg testoutp.jpg )
mytest ( t6 jpegtran "-outfile testoutt.jpg ${_src}/testprog.jpg" ${_src}/testorig.jpg 
  testoutt.jpg )

=== python/requirements.txt ===
# After updating this file, run:
# $ bazel run //tools/python:requirements.update

jinja2
matplotlib
mkdocs
numpy
opencv-python
osqp
pkginfo
pygobject
requests
scipy
shapely
validators
yapf

# TODO(phil): Migrate to absl-py. These are abandoned as far as I can tell.
python-gflags
glog

=== allwpilib/apriltag/CMakeLists.txt ===
project(apriltag)

include(CompileWarnings)
include(GenResources)
include(FetchContent)

fetchcontent_declare(
    apriltaglib
    GIT_REPOSITORY https://github.com/wpilibsuite/apriltag.git
    GIT_TAG 64be6ab26abf5e995321997fd0752c609a7e30f4
)

# Don't use apriltag's CMakeLists.txt due to conflicting naming and JNI
fetchcontent_getproperties(apriltaglib)
if(NOT apriltaglib_POPULATED)
    fetchcontent_populate(apriltaglib)
endif()

aux_source_directory(${apriltaglib_SOURCE_DIR}/common APRILTAGLIB_COMMON_SRC)
file(GLOB TAG_FILES ${apriltaglib_SOURCE_DIR}/tag*.c)
set(APRILTAGLIB_SRCS
    ${apriltaglib_SOURCE_DIR}/apriltag.c
    ${apriltaglib_SOURCE_DIR}/apriltag_pose.c
    ${apriltaglib_SOURCE_DIR}/apriltag_quad_thresh.c
)

file(GLOB apriltag_jni_src src/main/native/cpp/jni/AprilTagJNI.cpp)

if(WITH_JAVA)
    find_package(Java REQUIRED)
    find_package(JNI REQUIRED)
    include(UseJava)
    set(CMAKE_JAVA_COMPILE_FLAGS "-encoding" "UTF8" "-Xlint:unchecked")

    set(CMAKE_JNI_TARGET true)

    file(GLOB EJML_JARS "${WPILIB_BINARY_DIR}/wpimath/thirdparty/ejml/*.jar")
    file(GLOB JACKSON_JARS "${WPILIB_BINARY_DIR}/wpiutil/thirdparty/jackson/*.jar")
    find_file(
        OPENCV_JAR_FILE
        NAMES opencv-${OpenCV_VERSION_MAJOR}${OpenCV_VERSION_MINOR}${OpenCV_VERSION_PATCH}.jar
        PATHS
            ${OPENCV_JAVA_INSTALL_DIR}
            ${OpenCV_INSTALL_PATH}/bin
            ${OpenCV_INSTALL_PATH}/share/java
        NO_DEFAULT_PATH
    )

    set(CMAKE_JAVA_INCLUDE_PATH apriltag.jar ${EJML_JARS} ${JACKSON_JARS})

    file(GLOB_RECURSE JAVA_SOURCES src/main/java/*.java)
    file(
        GLOB_RECURSE JAVA_RESOURCES
        RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
        src/main/native/resources/*.json
    )
    add_jar(
        apriltag_jar
        SOURCES ${JAVA_SOURCES}
        RESOURCES
        NAMESPACE "edu/wpi/first/apriltag" ${JAVA_RESOURCES}
        INCLUDE_JARS wpimath_jar wpiunits_jar ${EJML_JARS} wpiutil_jar ${OPENCV_JAR_FILE}
        OUTPUT_NAME apriltag
        GENERATE_NATIVE_HEADERS apriltag_jni_headers
    )

    install_jar(apriltag_jar DESTINATION ${java_lib_dest})
    install_jar_exports(TARGETS apriltag_jar FILE apriltag_jar.cmake DESTINATION share/apriltag)

    add_library(apriltagjni ${apriltag_jni_src})
    wpilib_target_warnings(apriltagjni)
    target_link_libraries(apriltagjni PUBLIC apriltag)

    set_property(TARGET apriltagjni PROPERTY FOLDER "libraries")

    target_link_libraries(apriltagjni PRIVATE apriltag_jni_headers)
    add_dependencies(apriltagjni apriltag_jar)

    install(TARGETS apriltagjni EXPORT apriltagjni)
endif()

if(WITH_JAVA_SOURCE)
    find_package(Java REQUIRED)
    include(UseJava)
    file(GLOB APRILTAG_SOURCES src/main/java/edu/wpi/first/apriltag/*.java)
    add_jar(
        apriltag_src_jar
        RESOURCES
        NAMESPACE "edu/wpi/first/apriltag" ${APRILTAG_SOURCES}
        NAMESPACE
            "edu/wpi/first/apriltag/jni"
            src/main/java/edu/wpi/first/apriltag/jni/AprilTagJNI.java
        OUTPUT_NAME apriltag-sources
    )

    get_property(APRILTAG_SRC_JAR_FILE TARGET apriltag_src_jar PROPERTY JAR_FILE)
    install(FILES ${APRILTAG_SRC_JAR_FILE} DESTINATION "${java_lib_dest}")

    set_property(TARGET apriltag_src_jar PROPERTY FOLDER "java")
endif()

generate_resources(src/main/native/resources/edu/wpi/first/apriltag generated/main/cpp APRILTAG frc apriltag_resources_src)

file(GLOB apriltag_native_src src/main/native/cpp/*.cpp)

add_library(
    apriltag
    ${apriltag_native_src}
    ${apriltag_resources_src}
    ${APRILTAGLIB_SRCS}
    ${APRILTAGLIB_COMMON_SRC}
    ${TAG_FILES}
)
set_target_properties(apriltag PROPERTIES DEBUG_POSTFIX "d")

set_property(TARGET apriltag PROPERTY FOLDER "libraries")
target_compile_features(apriltag PUBLIC cxx_std_20)
wpilib_target_warnings(apriltag)
# disable warnings that apriltaglib can't handle
if(MSVC)
    target_compile_options(apriltag PRIVATE /wd4018 /wd4005 /wd4996)
else()
    target_compile_options(
        apriltag
        PRIVATE -Wno-sign-compare -Wno-gnu-zero-variadic-macro-arguments -Wno-type-limits
    )
endif()

target_link_libraries(apriltag wpimath)

target_include_directories(
    apriltag
    PUBLIC
        $<BUILD_INTERFACE:${apriltaglib_SOURCE_DIR}>
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/main/native/include>
        $<INSTALL_INTERFACE:${include_dest}/apriltag>
)

install(TARGETS apriltag EXPORT apriltag)
install(DIRECTORY src/main/native/include/ DESTINATION "${include_dest}/apriltag")

configure_file(apriltag-config.cmake.in ${WPILIB_BINARY_DIR}/apriltag-config.cmake)
install(FILES ${WPILIB_BINARY_DIR}/apriltag-config.cmake DESTINATION share/apriltag)
install(EXPORT apriltag DESTINATION share/apriltag)

if(WITH_TESTS)
    wpilib_add_test(apriltag src/test/native/cpp)
    target_include_directories(apriltag_test PRIVATE src/test/native/include)
    target_link_libraries(apriltag_test apriltag gmock_main)
endif()

=== allwpilib/cameraserver/CMakeLists.txt ===
project(cameraserver)

include(CompileWarnings)
include(AddTest)

find_package(OpenCV REQUIRED)

# Java bindings
if(WITH_JAVA)
    find_package(Java REQUIRED)
    include(UseJava)
    set(CMAKE_JAVA_COMPILE_FLAGS "-encoding" "UTF8" "-Xlint:unchecked")

    #find java files, copy them locally

    set(OPENCV_JAVA_INSTALL_DIR ${OpenCV_INSTALL_PATH}/share/OpenCV/java/)

    find_file(
        OPENCV_JAR_FILE
        NAMES opencv-${OpenCV_VERSION_MAJOR}${OpenCV_VERSION_MINOR}${OpenCV_VERSION_PATCH}.jar
        PATHS ${OPENCV_JAVA_INSTALL_DIR} ${OpenCV_INSTALL_PATH}/bin
        NO_DEFAULT_PATH
    )

    file(GLOB_RECURSE JAVA_SOURCES src/main/java/*.java)

    add_jar(
        cameraserver_jar
        ${JAVA_SOURCES}
        INCLUDE_JARS wpiutil_jar cscore_jar ntcore_jar ${OPENCV_JAR_FILE}
        OUTPUT_NAME cameraserver
    )

    install_jar(cameraserver_jar DESTINATION ${java_lib_dest})
    install_jar_exports(
        TARGETS cameraserver_jar
        FILE cameraserver_jar.cmake
        DESTINATION share/cameraserver
    )
endif()

if(WITH_JAVA_SOURCE)
    find_package(Java REQUIRED)
    include(UseJava)
    file(GLOB CAMERASERVER_SOURCES src/main/java/edu/wpi/first/cameraserver/*.java)
    file(GLOB VISION_SOURCES src/main/java/edu/wpi/first/vision/*.java)
    add_jar(
        cameraserver_src_jar
        RESOURCES
        NAMESPACE "edu/wpi/first/cameraserver" ${CAMERASERVER_SOURCES}
        NAMESPACE "edu/wpi/first/vision" ${VISION_SOURCES}
        OUTPUT_NAME cameraserver-sources
    )

    get_property(CAMERASERVER_SRC_JAR_FILE TARGET cameraserver_src_jar PROPERTY JAR_FILE)
    install(FILES ${CAMERASERVER_SRC_JAR_FILE} DESTINATION "${java_lib_dest}")

    set_property(TARGET cameraserver_src_jar PROPERTY FOLDER "java")
endif()

file(GLOB_RECURSE cameraserver_native_src src/main/native/cpp/*.cpp)
add_library(cameraserver ${cameraserver_native_src})
set_target_properties(cameraserver PROPERTIES DEBUG_POSTFIX "d")
target_include_directories(
    cameraserver
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/main/native/include>
        $<INSTALL_INTERFACE:${include_dest}/cameraserver>
)
wpilib_target_warnings(cameraserver)
target_link_libraries(cameraserver PUBLIC ntcore cscore wpiutil ${OpenCV_LIBS})

set_property(TARGET cameraserver PROPERTY FOLDER "libraries")

install(TARGETS cameraserver EXPORT cameraserver)
install(DIRECTORY src/main/native/include/ DESTINATION "${include_dest}/cameraserver")

configure_file(cameraserver-config.cmake.in ${WPILIB_BINARY_DIR}/cameraserver-config.cmake)
install(FILES ${WPILIB_BINARY_DIR}/cameraserver-config.cmake DESTINATION share/cameraserver)
install(EXPORT cameraserver DESTINATION share/cameraserver)

file(GLOB multiCameraServer_src multiCameraServer/src/main/native/cpp/*.cpp)
add_executable(multiCameraServer ${multiCameraServer_src})
wpilib_target_warnings(multiCameraServer)
target_link_libraries(multiCameraServer cameraserver)

set_property(TARGET multiCameraServer PROPERTY FOLDER "examples")

if(WITH_TESTS)
    wpilib_add_test(cameraserver src/test/native/cpp)
    target_link_libraries(cameraserver_test cameraserver gtest)
endif()

=== allwpilib/cscore/CMakeLists.txt ===
project(cscore)

include(SubDirList)
include(CompileWarnings)
include(AddTest)
include(LinkMacOSGUI)

find_package(OpenCV REQUIRED)

file(GLOB cscore_native_src src/main/native/cpp/*.cpp)
file(GLOB cscore_linux_src src/main/native/linux/*.cpp)
file(GLOB cscore_osx_src src/main/native/osx/*.cpp)
file(GLOB cscore_osx_objc_src src/main/native/objcpp/*.mm)
file(GLOB cscore_windows_src src/main/native/windows/*.cpp)

add_library(cscore ${cscore_native_src})
set_target_properties(cscore PROPERTIES DEBUG_POSTFIX "d")

if(NOT MSVC)
    if(APPLE)
        target_sources(cscore PRIVATE ${cscore_osx_src} ${cscore_osx_objc_src})
        target_compile_options(cscore PRIVATE "-fobjc-arc")
        set_target_properties(
            cscore
            PROPERTIES
                LINK_FLAGS
                    "-framework CoreFoundation -framework AVFoundation -framework Foundation -framework CoreMedia -framework CoreVideo"
        )
    else()
        target_sources(cscore PRIVATE ${cscore_linux_src})
    endif()
else()
    target_sources(cscore PRIVATE ${cscore_windows_src})
    target_compile_definitions(cscore PUBLIC -DNOMINMAX)
    target_compile_definitions(cscore PRIVATE -D_CRT_SECURE_NO_WARNINGS)
endif()

target_include_directories(
    cscore
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/main/native/include>
        $<INSTALL_INTERFACE:${include_dest}/cscore>
)
target_include_directories(cscore PRIVATE src/main/native/cpp)
wpilib_target_warnings(cscore)
target_link_libraries(cscore PUBLIC wpinet wpiutil ${OpenCV_LIBS})

set_property(TARGET cscore PROPERTY FOLDER "libraries")

install(TARGETS cscore EXPORT cscore)
install(DIRECTORY src/main/native/include/ DESTINATION "${include_dest}/cscore")

configure_file(cscore-config.cmake.in ${WPILIB_BINARY_DIR}/cscore-config.cmake)
install(FILES ${WPILIB_BINARY_DIR}/cscore-config.cmake DESTINATION share/cscore)
install(EXPORT cscore DESTINATION share/cscore)

subdir_list(cscore_examples "${CMAKE_CURRENT_SOURCE_DIR}/examples")
foreach(example ${cscore_examples})
    file(GLOB cscore_example_src examples/${example}/*.cpp)
    unset(add_libs)
    if(${example} STREQUAL "usbviewer")
        if(TARGET wpigui)
            set(add_libs wpigui)
        else()
            unset(cscore_example_src)
        endif()
    endif()
    if(cscore_example_src)
        add_executable(cscore_${example} ${cscore_example_src})
        wpilib_target_warnings(cscore_${example})

        if(${example} STREQUAL "usbviewer")
            wpilib_link_macos_gui(cscore_${example})
        endif()

        target_link_libraries(cscore_${example} cscore ${add_libs})
        set_property(TARGET cscore_${example} PROPERTY FOLDER "examples")
    endif()
endforeach()

# Java bindings
if(WITH_JAVA)
    find_package(Java REQUIRED)
    find_package(JNI REQUIRED)
    include(UseJava)
    set(CMAKE_JAVA_COMPILE_FLAGS "-encoding" "UTF8" "-Xlint:unchecked")

    #find java files, copy them locally

    if("${OPENCV_JAVA_INSTALL_DIR}" STREQUAL "")
        set(OPENCV_JAVA_INSTALL_DIR ${OpenCV_INSTALL_PATH}/share/OpenCV/java/)
    endif()

    find_file(
        OPENCV_JAR_FILE
        NAMES opencv-${OpenCV_VERSION_MAJOR}${OpenCV_VERSION_MINOR}${OpenCV_VERSION_PATCH}.jar
        PATHS
            ${OPENCV_JAVA_INSTALL_DIR}
            ${OpenCV_INSTALL_PATH}/bin
            ${OpenCV_INSTALL_PATH}/share/java
        NO_DEFAULT_PATH
    )
    find_file(
        OPENCV_JNI_FILE
        NAMES
            libopencv_java${OpenCV_VERSION_MAJOR}${OpenCV_VERSION_MINOR}${OpenCV_VERSION_PATCH}.so
            libopencv_java${OpenCV_VERSION_MAJOR}${OpenCV_VERSION_MINOR}${OpenCV_VERSION_PATCH}.dylib
            opencv_java${OpenCV_VERSION_MAJOR}${OpenCV_VERSION_MINOR}${OpenCV_VERSION_PATCH}.dll
        PATHS
            ${OPENCV_JAVA_INSTALL_DIR}
            ${OpenCV_INSTALL_PATH}/bin
            ${OpenCV_INSTALL_PATH}/bin/Release
            ${OpenCV_INSTALL_PATH}/bin/Debug
            ${OpenCV_INSTALL_PATH}/lib
            ${OpenCV_INSTALL_PATH}/lib/jni
        NO_DEFAULT_PATH
    )

    file(GLOB cscore_jni_src src/main/native/cpp/jni/CameraServerJNI.cpp)

    file(GLOB_RECURSE JAVA_SOURCES src/main/java/*.java)
    set(CMAKE_JNI_TARGET true)

    add_jar(
        cscore_jar
        ${JAVA_SOURCES}
        INCLUDE_JARS wpiutil_jar ${OPENCV_JAR_FILE}
        OUTPUT_NAME cscore
        GENERATE_NATIVE_HEADERS cscore_jni_headers
    )

    install_jar(cscore_jar DESTINATION ${java_lib_dest})
    install_jar_exports(TARGETS cscore_jar FILE cscore_jar.cmake DESTINATION share/cscore)
    install(FILES ${OPENCV_JAR_FILE} DESTINATION "${java_lib_dest}")

    if(MSVC)
        install(FILES ${OPENCV_JNI_FILE} DESTINATION "${jni_lib_dest}")

        foreach(cvFile ${OpenCV_LIBS})
            find_file(
                ${cvFile}Loc
                NAMES
                    ${cvFile}${OpenCV_VERSION_MAJOR}${OpenCV_VERSION_MINOR}${OpenCV_VERSION_PATCH}.dll
                PATHS
                    ${OPENCV_JAVA_INSTALL_DIR}
                    ${OpenCV_INSTALL_PATH}/bin
                    ${OpenCV_INSTALL_PATH}/bin/Release
                    ${OpenCV_INSTALL_PATH}/bin/Debug
                    ${OpenCV_INSTALL_PATH}/lib
                NO_DEFAULT_PATH
            )
            install(FILES ${${cvFile}Loc} DESTINATION "${jni_lib_dest}")
        endforeach()
    endif()

    add_library(cscorejni ${cscore_jni_src})
    wpilib_target_warnings(cscorejni)
    target_link_libraries(cscorejni PUBLIC cscore wpiutil ${OpenCV_LIBS})

    set_property(TARGET cscorejni PROPERTY FOLDER "libraries")

    target_link_libraries(cscorejni PRIVATE cscore_jni_headers)
    add_dependencies(cscorejni cscore_jar)

    install(TARGETS cscorejni EXPORT cscorejni)
endif()

if(WITH_JAVA_SOURCE)
    find_package(Java REQUIRED)
    include(UseJava)
    file(GLOB CSCORE_SOURCES src/main/java/edu/wpi/first/cscore/*.java)
    file(GLOB CSCORE_RAW_SOURCES src/main/java/edu/wpi/first/cscore/raw/*.java)
    add_jar(
        cscore_src_jar
        RESOURCES
        NAMESPACE "edu/wpi/first/cscore" ${CSCORE_SOURCES}
        NAMESPACE "edu/wpi/first/cscore/raw" ${CSCORE_RAW_SOURCES}
        OUTPUT_NAME cscore-sources
    )

    get_property(CSCORE_SRC_JAR_FILE TARGET cscore_src_jar PROPERTY JAR_FILE)
    install(FILES ${CSCORE_SRC_JAR_FILE} DESTINATION "${java_lib_dest}")

    set_property(TARGET cscore_src_jar PROPERTY FOLDER "java")
endif()

if(WITH_TESTS)
    wpilib_add_test(cscore src/test/native/cpp)
    target_link_libraries(cscore_test cscore gmock)
endif()

=== allwpilib/datalogtool/CMakeLists.txt ===
project(datalogtool)

include(CompileWarnings)
include(GenResources)
include(LinkMacOSGUI)

configure_file(src/main/generate/WPILibVersion.cpp.in WPILibVersion.cpp)
generate_resources(src/main/native/resources generated/main/cpp DLT dlt datalogtool_resources_src)

file(GLOB datalogtool_src src/main/native/cpp/*.cpp ${CMAKE_CURRENT_BINARY_DIR}/WPILibVersion.cpp)

if(WIN32)
    set(datalogtool_rc src/main/native/win/datalogtool.rc)
elseif(APPLE)
    set(MACOSX_BUNDLE_ICON_FILE datalogtool.icns)
    set(APP_ICON_MACOSX src/main/native/mac/datalogtool.icns)
    set_source_files_properties(${APP_ICON_MACOSX} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
endif()

add_executable(
    datalogtool
    ${datalogtool_src}
    ${datalogtool_resources_src}
    ${datalogtool_rc}
    ${APP_ICON_MACOSX}
)
wpilib_link_macos_gui(datalogtool)
target_link_libraries(datalogtool libglass ${LIBSSH_LIBRARIES})
target_include_directories(datalogtool SYSTEM PRIVATE ${LIBSSH_INCLUDE_DIRS})

if(WIN32)
    set_target_properties(datalogtool PROPERTIES WIN32_EXECUTABLE YES)
elseif(APPLE)
    set_target_properties(datalogtool PROPERTIES MACOSX_BUNDLE YES OUTPUT_NAME "datalogTool")
endif()

=== allwpilib/fieldImages/CMakeLists.txt ===
project(fieldImages)

include(CompileWarnings)
include(GenResources)

if(WITH_JAVA)
    find_package(Java REQUIRED)
    include(UseJava)

    file(GLOB JACKSON_JARS "${WPILIB_BINARY_DIR}/wpiutil/thirdparty/jackson/*.jar")
    set(CMAKE_JAVA_INCLUDE_PATH fieldImages.jar ${JACKSON_JARS})

    file(GLOB_RECURSE JAVA_SOURCES src/main/java/*.java)
    file(
        GLOB_RECURSE JAVA_RESOURCES
        RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
        src/main/native/resources/*.json
        src/main/native/resources/*.png
        src/main/native/resources/*.jpg
    )
    add_jar(
        field_images_jar
        SOURCES ${JAVA_SOURCES}
        RESOURCES
        NAMESPACE "edu/wpi/first/fields" ${JAVA_RESOURCES}
        OUTPUT_NAME fieldImages
    )

    get_property(FIELD_IMAGES_JAR_FILE TARGET field_images_jar PROPERTY JAR_FILE)
    install(FILES ${FIELD_IMAGES_JAR_FILE} DESTINATION "${java_lib_dest}")

    set_property(TARGET field_images_jar PROPERTY FOLDER "java")
endif()

generate_resources(src/main/native/resources/edu/wpi/first/fields generated/main/cpp FIELDS fields field_images_resources_src)

add_library(fieldImages src/main/native/cpp/fields.cpp ${field_images_resources_src})
set_target_properties(fieldImages PROPERTIES DEBUG_POSTFIX "d")

set_property(TARGET fieldImages PROPERTY FOLDER "libraries")
target_compile_features(fieldImages PUBLIC cxx_std_20)
if(MSVC)
    target_compile_options(fieldImages PUBLIC /bigobj)
endif()
wpilib_target_warnings(fieldImages)

target_include_directories(
    fieldImages
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/main/native/include>
        $<INSTALL_INTERFACE:${include_dest}/fields>
)

=== allwpilib/glass/CMakeLists.txt ===
project(glass)

include(CompileWarnings)
include(GenResources)
include(LinkMacOSGUI)

#
# libglass
#
file(GLOB_RECURSE libglass_src src/lib/native/cpp/*.cpp)

add_library(libglass ${libglass_src})
set_target_properties(libglass PROPERTIES DEBUG_POSTFIX "d" OUTPUT_NAME "glass")
set_property(TARGET libglass PROPERTY POSITION_INDEPENDENT_CODE ON)

set_property(TARGET libglass PROPERTY FOLDER "libraries")

wpilib_target_warnings(libglass)
target_link_libraries(libglass PUBLIC wpigui wpimath wpiutil fieldImages)

target_include_directories(
    libglass
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/lib/native/include>
        $<INSTALL_INTERFACE:${include_dest}/glass>
)

install(TARGETS libglass EXPORT libglass)
install(DIRECTORY src/lib/native/include/ DESTINATION "${include_dest}/glass")

#
# libglassnt
#
file(GLOB_RECURSE libglassnt_src src/libnt/native/cpp/*.cpp)

add_library(libglassnt ${libglassnt_src})
set_target_properties(libglassnt PROPERTIES DEBUG_POSTFIX "d" OUTPUT_NAME "glassnt")
set_property(TARGET libglassnt PROPERTY POSITION_INDEPENDENT_CODE ON)

set_property(TARGET libglassnt PROPERTY FOLDER "libraries")

wpilib_target_warnings(libglassnt)
target_link_libraries(libglassnt PUBLIC ntcore libglass)

target_include_directories(
    libglassnt
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/libnt/native/include>
        $<INSTALL_INTERFACE:${include_dest}/glass>
)

install(TARGETS libglassnt EXPORT libglassnt)
install(DIRECTORY src/libnt/native/include/ DESTINATION "${include_dest}/glass")

#
# glass application
#

configure_file(src/app/generate/WPILibVersion.cpp.in WPILibVersion.cpp)
generate_resources(src/app/native/resources generated/app/cpp GLASS glass glass_resources_src)

file(GLOB glass_src src/app/native/cpp/*.cpp ${CMAKE_CURRENT_BINARY_DIR}/WPILibVersion.cpp)

if(WIN32)
    set(glass_rc src/app/native/win/glass.rc)
elseif(APPLE)
    set(MACOSX_BUNDLE_ICON_FILE glass.icns)
    set(APP_ICON_MACOSX src/app/native/mac/glass.icns)
    set_source_files_properties(${APP_ICON_MACOSX} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
endif()

add_executable(glass ${glass_src} ${glass_resources_src} ${glass_rc} ${APP_ICON_MACOSX})
wpilib_link_macos_gui(glass)
wpilib_target_warnings(glass)
target_link_libraries(glass libglassnt libglass)

if(WIN32)
    set_target_properties(glass PROPERTIES WIN32_EXECUTABLE YES)
elseif(APPLE)
    set_target_properties(glass PROPERTIES MACOSX_BUNDLE YES OUTPUT_NAME "Glass")
endif()

=== allwpilib/googletest/CMakeLists.txt ===
include(FetchContent)

fetchcontent_declare(
    googletest
    GIT_REPOSITORY https://github.com/google/googletest.git
    GIT_TAG
        58d77fa8070e8cec2dc1ed015d66b454c8d78850 # 1.12.1
)

fetchcontent_getproperties(googletest)
if(NOT googletest_POPULATED)
    fetchcontent_populate(googletest)

    # Prevent overriding the parent project's compiler/linker
    # settings on Windows
    set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)

    add_subdirectory(${googletest_SOURCE_DIR} ${googletest_BINARY_DIR} EXCLUDE_FROM_ALL)
endif()

target_compile_features(gtest PUBLIC cxx_std_20)
target_compile_features(gtest_main PUBLIC cxx_std_20)
target_compile_features(gmock PUBLIC cxx_std_20)
target_compile_features(gmock_main PUBLIC cxx_std_20)

=== allwpilib/hal/CMakeLists.txt ===
project(hal)

include(CompileWarnings)
include(AddTest)

file(
    GLOB hal_shared_native_src
    src/main/native/cpp/*.cpp
    hal_shared_native_src
    src/main/native/cpp/cpp/*.cpp
    hal_shared_native_src
    src/main/native/cpp/handles/*.cpp
    hal_sim_native_src
    src/main/native/sim/*.cpp
    hal_sim_native_src
    src/main/native/sim/mockdata/*.cpp
)
add_library(hal ${hal_shared_native_src})
wpilib_target_warnings(hal)
set_target_properties(hal PROPERTIES DEBUG_POSTFIX "d")

if(USE_EXTERNAL_HAL)
    include(${EXTERNAL_HAL_FILE})
else()
    target_sources(hal PRIVATE ${hal_sim_native_src})
endif()

set_target_properties(hal PROPERTIES OUTPUT_NAME "wpiHal")

target_include_directories(
    hal
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/main/native/include>
        $<INSTALL_INTERFACE:${include_dest}/hal>
)

target_include_directories(
    hal
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/generated/main/native/include>
        $<INSTALL_INTERFACE:${include_dest}/hal>
)
target_link_libraries(hal PUBLIC wpiutil)

set_property(TARGET hal PROPERTY FOLDER "libraries")

install(TARGETS hal EXPORT hal)
install(DIRECTORY src/main/native/include/ DESTINATION "${include_dest}/hal")
install(DIRECTORY src/generated/main/native/include/ DESTINATION "${include_dest}/hal")

configure_file(hal-config.cmake.in ${WPILIB_BINARY_DIR}/hal-config.cmake)
install(FILES ${WPILIB_BINARY_DIR}/hal-config.cmake DESTINATION share/hal)
install(EXPORT hal DESTINATION share/hal)

# Java bindings
if(WITH_JAVA)
    find_package(Java REQUIRED)
    find_package(JNI REQUIRED)
    include(UseJava)
    set(CMAKE_JAVA_COMPILE_FLAGS "-encoding" "UTF8" "-Xlint:unchecked")

    configure_file(src/generate/FRCNetComm.java.in FRCNetComm.java)

    file(GLOB_RECURSE hal_shared_jni_src src/main/native/cpp/jni/*.cpp)

    file(GLOB_RECURSE JAVA_SOURCES src/main/java/*.java src/generated/main/java/*.java)
    set(CMAKE_JNI_TARGET true)

    add_jar(
        hal_jar
        ${JAVA_SOURCES}
        INCLUDE_JARS wpiutil_jar
        OUTPUT_NAME wpiHal
        GENERATE_NATIVE_HEADERS hal_jni_headers
    )

    install_jar(hal_jar DESTINATION ${java_lib_dest})
    install_jar_exports(TARGETS hal_jar FILE hal_jar.cmake DESTINATION share/hal)

    add_library(haljni ${hal_shared_jni_src})

    if(USE_EXTERNAL_HAL)
        include(${EXTERNAL_HAL_FILE})
    endif()

    set_target_properties(haljni PROPERTIES OUTPUT_NAME "wpiHaljni")

    wpilib_target_warnings(haljni)
    target_link_libraries(haljni PUBLIC hal wpiutil)

    set_property(TARGET haljni PROPERTY FOLDER "libraries")

    target_link_libraries(haljni PRIVATE hal_jni_headers)
    add_dependencies(haljni hal_jar)

    install(TARGETS haljni EXPORT haljni)
endif()

if(WITH_JAVA_SOURCE)
    find_package(Java REQUIRED)
    include(UseJava)
    file(GLOB HAL_SOURCES src/main/java/edu/wpi/first/hal/*.java src/generated/main/java/*.java)
    file(GLOB HAL_CAN_SOURCES src/main/java/edu/wpi/first/hal/can/*.java)
    file(GLOB HAL_SIMULATION_SOURCES src/main/java/edu/wpi/first/hal/simulation/*.java)
    file(GLOB HAL_UTIL_SOURCES src/main/java/edu/wpi/first/hal/util/*.java)
    add_jar(
        hal_src_jar
        RESOURCES
        NAMESPACE "edu/wpi/first/hal" ${HAL_SOURCES}
        NAMESPACE "edu/wpi/first/hal/can" ${HAL_CAN_SOURCES}
        NAMESPACE
            "edu/wpi/first/hal/communication"
            src/main/java/edu/wpi/first/hal/communication/NIRioStatus.java
        NAMESPACE "edu/wpi/first/hal/simulation" ${HAL_SIMULATION_SOURCES}
        NAMESPACE "edu/wpi/first/hal/util" ${HAL_UTIL_SOURCES}
        OUTPUT_NAME wpiHal-sources
    )

    get_property(HAL_SRC_JAR_FILE TARGET hal_src_jar PROPERTY JAR_FILE)
    install(FILES ${HAL_SRC_JAR_FILE} DESTINATION "${java_lib_dest}")

    set_property(TARGET hal_src_jar PROPERTY FOLDER "java")
endif()

if(WITH_TESTS)
    wpilib_add_test(hal src/test/native/cpp)
    target_link_libraries(hal_test hal gtest)
endif()

=== rawrtc/re/debian/changelog ===
libre (0.6.0-3) unstable; urgency=medium

  * version 0.6.0-3

 -- Richard Aas <richaraas@gmail.com>  Fri, 1 Feb 2019 12:00:00 +0100

libre (0.6.0-2) unstable; urgency=medium

  * version 0.6.0-2

 -- Richard Aas <richaraas@gmail.com>  Tue, 11 Dec 2018 10:00:00 +0100

libre (0.6.0-1) unstable; urgency=medium

  * version 0.6.0-1

 -- Richard Aas <richard@db.org>  Fri, 30 Nov 2018 10:00:00 +0100

libre (0.6.0) unstable; urgency=medium

  * version 0.6.0

 -- Alfred E. Heggestad <alfred.heggestad@gmail.com>  Sat, 24 Nov 2018 10:00:00 +0100

libre (0.5.9) unstable; urgency=medium

  * version 0.5.9

 -- Alfred E. Heggestad <alfred.heggestad@gmail.com>  Sat, 1 Sep 2018 10:00:00 +0200

libre (0.5.8) unstable; urgency=medium

  * version 0.5.8

 -- Alfred E. Heggestad <alfred.heggestad@gmail.com>  Fri, 20 Apr 2018 16:00:00 +0200

libre (0.5.7) unstable; urgency=medium

  * version 0.5.7

 -- Alfred E. Heggestad <alfred.heggestad@gmail.com>  Fri, 12 Jan 2018 18:00:00 +0100

libre (0.5.6) unstable; urgency=medium

  * version 0.5.6

 -- Alfred E. Heggestad <alfred.heggestad@gmail.com>  Mon, 6 Nov 2017 15:00:00 +0100

libre (0.5.5) unstable; urgency=medium

  * version 0.5.5

 -- Alfred E. Heggestad <alfred.heggestad@gmail.com>  Tue, 5 Sep 2017 12:00:00 +0200

libre (0.5.4) unstable; urgency=medium

  * version 0.5.4

 -- Alfred E. Heggestad <alfred.heggestad@gmail.com>  Sat, 24 Jun 2017 12:00:00 +0200

libre (0.5.3) unstable; urgency=medium

  * version 0.5.3

 -- Alfred E. Heggestad <alfred.heggestad@gmail.com>  Sat, 13 May 2017 12:00:00 +0200

libre (0.5.2) unstable; urgency=medium

  * version 0.5.2

 -- Alfred E. Heggestad <alfred.heggestad@gmail.com>  Sat, 08 Apr 2017 12:00:00 +0200

libre (0.5.1) unstable; urgency=medium

  * version 0.5.1

 -- Alfred E. Heggestad <alfred.heggestad@gmail.com>  Sat, 04 Feb 2017 12:00:00 +0100

libre (0.5.0) unstable; urgency=medium

  * version 0.5.0

 -- Alfred E. Heggestad <alfred.heggestad@gmail.com>  Fri, 25 Nov 2016 18:00:00 +0100

libre (0.4.17) unstable; urgency=medium

  * version 0.4.17

 -- Alfred E. Heggestad <aeh@db.org>  Fri, 24 Jun 2016 15:00:00 +0100

libre (0.4.16) unstable; urgency=medium

  * version 0.4.16

 -- Alfred E. Heggestad <aeh@db.org>  Wed, 27 Apr 2016 20:00:00 +0100

libre (0.4.15) unstable; urgency=medium

  * version 0.4.15

 -- Alfred E. Heggestad <aeh@db.org>  Sat, 06 Feb 2016 04:15:00 +0100

libre (0.4.14) unstable; urgency=low

  * version 0.4.14

 -- Alfred E. Heggestad <aeh@db.org>  Sat, 24 Oct 2015 20:00:00 +0100

libre (0.4.13-1) unstable; urgency=low

  * version 0.4.13-1

 -- Richard Aas <richard@db.org>  Thu, 08 Oct 2015 10:35:00 +0100

libre (0.4.13) unstable; urgency=low

  * version 0.4.13

 -- Alfred E. Heggestad <aeh@db.org>  Wed, 01 July 2015 20:00:00 +0100

libre (0.4.12) unstable; urgency=low

  * version 0.4.12

 -- Alfred E. Heggestad <aeh@db.org>  Mon, 16 Mar 2015 20:00:00 +0100

libre (0.4.11) unstable; urgency=low

  * version 0.4.11

 -- Alfred E. Heggestad <aeh@db.org>  Tue, 9 Dec 2014 20:00:00 +0100

libre (0.4.10-2) unstable; urgency=low

  * version 0.4.10-2

 -- Richard Aas <richard@db.org>  Mon, 17 Nov 2014 09:09:00 +0100

libre (0.4.10-1) unstable; urgency=low

  * version 0.4.10-1

 -- Richard Aas <richard@db.org>  Fri, 14 Nov 2014 09:09:00 +0100

libre (0.4.10) unstable; urgency=low

  * version 0.4.10

 -- Alfred E. Heggestad <aeh@db.org>  Sun, 19 Oct 2014 19:00:00 +0100

libre (0.4.9) unstable; urgency=low

  * version 0.4.9

 -- Alfred E. Heggestad <aeh@db.org>  Wed, 18 Jun 2014 19:00:00 +0100

libre (0.4.8) unstable; urgency=low

  * version 0.4.8

 -- Alfred E. Heggestad <aeh@db.org>  Fri, 11 Apr 2014 19:00:00 +0100

libre (0.4.7) unstable; urgency=low

  * version 0.4.7

 -- Alfred E. Heggestad <aeh@db.org>  Sun, 5 Jan 2014 20:00:00 +0100

libre (0.4.6) unstable; urgency=low

  * version 0.4.6

 -- Alfred E. Heggestad <aeh@db.org>  Tue, 12 Nov 2013 20:00:00 +0100

libre (0.4.5) unstable; urgency=low

  * version 0.4.5

 -- Alfred E. Heggestad <aeh@db.org>  Thu, 3 Oct 2013 20:00:00 +0100

libre (0.4.4) unstable; urgency=low

  * version 0.4.4

 -- Alfred E. Heggestad <aeh@db.org>  Tue, 27 Aug 2013 20:00:00 +0100

libre (0.4.3) unstable; urgency=low

  * version 0.4.3

 -- Alfred E. Heggestad <aeh@db.org>  Sun, 5 May 2013 15:00:00 +0100

libre (0.4.2) unstable; urgency=low

  * version 0.4.2

 -- Alfred E. Heggestad <aeh@db.org>  Fri, 10 Aug 2012 10:08:00 +0100

libre (0.4.1) unstable; urgency=low

  * version 0.4.1

 -- Alfred E. Heggestad <aeh@db.org>  Sat, 21 Apr 2012 21:04:00 +0100

libre (0.4.0) unstable; urgency=low

  * version 0.4.0

 -- Alfred E. Heggestad <aeh@db.org>  Sun, 25 Dec 2011 12:25:00 +0100

libre (0.3.0) unstable; urgency=low

  * version 0.3.0

 -- Alfred E. Heggestad <aeh@db.org>  Wed, 7 Sept 2011 07:11:00 +0100

libre (0.2.0) unstable; urgency=low

  * version 0.2.0

 -- Alfred E. Heggestad <aeh@db.org>  Fri, 20 May 2011 20:05:00 +0100

libre (0.1.0) unstable; urgency=low

  * version 0.1.0

 -- Alfred E. Heggestad <aeh@db.org>  Fri, 5 Nov 2010 05:11:10 +0100

=== rawrtc/usrsctp/debian/control ===
Source: libusrsctp
Maintainer: Michael Tüxen <tuexen@fh-muenster.de>
Section: net
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               libfile-fcntllock-perl
Standards-Version: 3.9.8
Vcs-Browser: https://github.com/sctplib/usrsctp
Vcs-Git: https://github.com/sctplib/usrsctp.git
Homepage: https://github.com/sctplib/usrsctp

Package: libusrsctp1
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Portable SCTP Userland Stack
 This is a userland SCTP stack supporting FreeBSD, Linux, Mac OS X and Windows.
 .
 This package contains the shared library for the Portable SCTP Userland Stack.

Package: libusrsctp-dev
Architecture: any
Depends: libusrsctp1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Portable SCTP Userland Stack (Development Files)
 This is a userland SCTP stack supporting FreeBSD, Linux, Mac OS X and Windows.
 .
 This package contains the development files for the Portable SCTP Userland Stack.

Package: libusrsctp-examples
Architecture: any
Depends: libusrsctp1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Portable SCTP Userland Stack (Examples)
 This is a userland SCTP stack supporting FreeBSD, Linux, Mac OS X and Windows.
 .
 This package contains the examples for the Portable SCTP Userland Stack.

=== rawrtc/usrsctp/debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem cmake --parallel
